

<!-- Start index.js -->

@fileOverview
A simple promises-based check to see if a TCP port is already in use.

Example usage:

var tcpPortUsed = require('tcp-port-used');

tcpPortUsed.check(22)
.then(function(inUse) {
   debug('Port 22 usage: '+inUse);
}, function(err) {
   console.error('Error on check: '+util.inspect(err));
});

## check(port)

Checks if a TCP port is in use by creating the socket and binding it to the
target port. Once bound, successfully, it's assume the port is availble.
After the socket is closed or in error, the promise is resolved.
Note: you have to be super user to correctly test system ports (0-1023).

### Params: 

* **Number** *port* The port you are curious to see if available.

### Return:

* **Object** A deferred Q promise.

## waitUntilFree(port, [retryTimeMs], [timeOutMs])

Creates a deferred promise and fulfills it only when the socket is free.
Will retry on an interval specified in retryTimeMs.
Note: you have to be super user to correctly test system ports (0-1023).

### Params: 

* **Number** *port* a valid TCP port number

* **Number** *[retryTimeMs]* the retry interval in milliseconds - defaultis is 100ms.

* **Number** *[timeOutMs]* the amount of time to wait until port is free. Default 300ms.

## waitUntilUsed(port, [retryTimeMs], [timeOutMs])

Creates a deferred promise and fulfills it only when the socket is used.
Will retry on an interval specified in retryTimeMs.
Note: you have to be super user to correctly test system ports (0-1023).

### Params: 

* **Number** *port* a valid TCP port number

* **Number** *[retryTimeMs]* the retry interval in milliseconds - defaultis is 500ms

* **Number** *[timeOutMs]* the amount of time to wait until port is free

<!-- End index.js -->

